variables:
  CONAN_NON_INTERACTIVE: 1
  CONAN_REFERENCE: "jaf_routing/0.0.2"
  CONAN_CHANNEL: "testing"

stages:
  - build
  - deploy

.setup: &setup
  before_script:
    - export CONAN_USERNAME=$(echo "${CI_PROJECT_PATH}" | sed -r 's/\//+/g')
    - conan remote add gitlab ${CI_API_V4_URL}/packages/conan

build:clang:
  image: conanio/clang9
  stage: build
  <<: *setup
  script:
    - conan install . --install-folder build --build missing
    - conan build . --build-folder build
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - conan test test ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} --build missing

deploy-testing:clang:
  image: conanio/clang9
  stage: deploy
  only:
    - master
  <<: *setup
  script:
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - CONAN_LOGIN_USERNAME=ci_user CONAN_PASSWORD=${CI_JOB_TOKEN} conan upload ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} --remote=gitlab
  
deploy-stable:clang:
  image: conanio/clang9
  stage: deploy
  only:
    - tags
  variables:
    CONAN_CHANNEL: "stable"
  <<: *setup
  script:
    - conan export . ${CONAN_USERNAME}/${CONAN_CHANNEL}
    - CONAN_LOGIN_USERNAME=ci_user CONAN_PASSWORD=${CI_JOB_TOKEN} conan upload ${CONAN_REFERENCE}@${CONAN_USERNAME}/${CONAN_CHANNEL} --remote=gitlab
